diff --git a/krita/ui/opengl/kis_opengl_image_textures.cpp b/krita/ui/opengl/kis_opengl_image_textures.cpp
index 6f21ebd..3da3710 100644
--- a/krita/ui/opengl/kis_opengl_image_textures.cpp
+++ b/krita/ui/opengl/kis_opengl_image_textures.cpp
@@ -98,10 +98,8 @@ KisOpenGLImageTextures::KisOpenGLImageTextures(KisImageWSP image, KoColorProfile
 
     createImageTextureTiles();
 
-    connect(m_image, SIGNAL(sigImageUpdated(QRect)), SLOT(slotImageUpdated(QRect)));
-    connect(m_image, SIGNAL(sigSizeChanged(qint32, qint32)), SLOT(slotImageSizeChanged(qint32, qint32)));
-
-    updateImageTextureTiles(m_image->bounds());
+    KisOpenGLUpdateInfoSP info = updateCache(m_image->bounds());
+    recalculateCache(info);
 }
 
 KisOpenGLImageTextures::~KisOpenGLImageTextures()
@@ -205,107 +203,93 @@ void KisOpenGLImageTextures::destroyImageTextureTiles()
     }
 }
 
-void KisOpenGLImageTextures::updateImageTextureTiles(const QRect& rect)
+KisOpenGLUpdateInfoSP
+KisOpenGLImageTextures::updateCache(const QRect& rect)
 {
-    //dbgUI << "updateImageTextureTiles" << rect;
+    KisOpenGLUpdateInfoSP info = new KisOpenGLUpdateInfo();
 
     QRect updateRect = rect & m_image->bounds();
+    if (updateRect.isEmpty()) return info;
 
-    if (!updateRect.isEmpty()) {
-
-        KisOpenGL::makeContextCurrent();
+    int firstColumn = updateRect.left() / m_imageTextureTileWidth;
+    int lastColumn = updateRect.right() / m_imageTextureTileWidth;
+    int firstRow = updateRect.top() / m_imageTextureTileHeight;
+    int lastRow = updateRect.bottom() / m_imageTextureTileHeight;
 
-        KIS_OPENGL_CLEAR_ERROR();
+    qint32 numItems = (lastColumn - firstColumn + 1) * (lastRow - firstRow + 1);
+    info->tileList.reserve(numItems);
 
-        int firstColumn = updateRect.left() / m_imageTextureTileWidth;
-        int lastColumn = updateRect.right() / m_imageTextureTileWidth;
-        int firstRow = updateRect.top() / m_imageTextureTileHeight;
-        int lastRow = updateRect.bottom() / m_imageTextureTileHeight;
+    for (int col = firstColumn; col <= lastColumn; col++) {
+        for (int row = firstRow; row <= lastRow; row++) {
 
-        for (int column = firstColumn; column <= lastColumn; column++) {
-            for (int row = firstRow; row <= lastRow; row++) {
+            QRect tileRect(col * m_imageTextureTileWidth, row * m_imageTextureTileHeight,
+                           m_imageTextureTileWidth, m_imageTextureTileHeight);
 
-                QRect tileRect(column * m_imageTextureTileWidth, row * m_imageTextureTileHeight,
-                               m_imageTextureTileWidth, m_imageTextureTileHeight);
+            KisTextureTileUpdateInfo tile(tileRect, updateRect);
+            tile.retrieveData(m_image);
+            info->tileList.append(tile);
+        }
+    }
+    return info;
+}
 
-                QRect tileUpdateRect = tileRect & updateRect;
+void KisOpenGLImageTextures::recalculateCache(KisUpdateInfoSP info)
+{
+    KisOpenGLUpdateInfoSP glInfo = dynamic_cast<KisOpenGLUpdateInfo*>(info.data());
+    if(!glInfo) return;
 
-                glBindTexture(GL_TEXTURE_2D, imageTextureTile(tileRect.x(), tileRect.y()));
-                glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
-                glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);//GL_LINEAR);
-                glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
-                glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
+    KisOpenGL::makeContextCurrent();
 
-                glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
+    KIS_OPENGL_CLEAR_ERROR();
 
-                QImage tileUpdateImage;
-                quint8 *pixels;
-                bool deletePixelsAfterUse = false;
+    KisTextureTileUpdateInfo tile;
 
-                if (m_imageTextureInternalFormat == GL_RGBA8) {
-                    tileUpdateImage = m_image->convertToQImage(tileUpdateRect.x(), tileUpdateRect.y(),
-                                                               tileUpdateRect.width(), tileUpdateRect.height(),
-                                                               m_monitorProfile);
+    foreach(tile, glInfo->tileList) {
+        glBindTexture(GL_TEXTURE_2D, imageTextureTile(tile.tileRect().x(), tile.tileRect().y()));
+        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
+        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);//GL_LINEAR);
+        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
+        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
 
-                    pixels = tileUpdateImage.bits();
-                }
-                else {
-                    pixels = new quint8[tileUpdateRect.width() * tileUpdateRect.height() * m_image->colorSpace()->pixelSize()];
-                    Q_CHECK_PTR(pixels);
-                    deletePixelsAfterUse = true;
+        glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
 
-                    m_image->projection()->readBytes(pixels, tileUpdateRect.x(), tileUpdateRect.y(),
-                                                      tileUpdateRect.width(), tileUpdateRect.height());
+        const KoColorSpace *dstCS;
 
+        switch(m_imageTextureType) {
+        case GL_UNSIGNED_BYTE:
+            dstCS = KoColorSpaceRegistry::instance()->rgb8(m_monitorProfile);
+            break;
 #if defined(HAVE_GLEW) && defined(HAVE_OPENEXR)
-
-                    if (m_imageTextureInternalFormat == GL_RGBA16) {
-                        // Convert to 16 bit rgba from the current colorspace (which is integer 16, float 16 or float 32, but not rgba)
-                        const KoColorSpace* rgb16 = KoColorSpaceRegistry::instance()->rgb16(m_monitorProfile);
-                        quint8* rgb16pixels = rgb16->allocPixelBuffer(tileUpdateRect.width() * tileUpdateRect.height());
-                        m_image->colorSpace()->convertPixelsTo(pixels, rgb16pixels, rgb16, tileUpdateRect.width() * tileUpdateRect.height());
-                        delete[] pixels;
-                        pixels = rgb16pixels;
-                    }
-                    else if (m_image->colorSpace()->colorDepthId() == Float16BitsColorDepthID && m_imageTextureType == GL_FLOAT) {
-                        // Convert half to float as we don't have ARB_half_float_pixel
-                        const int NUM_RGBA_COMPONENTS = 4;
-                        qint32 halfCount = tileUpdateRect.width() * tileUpdateRect.height() * NUM_RGBA_COMPONENTS;
-                        GLfloat *pixels_as_floats = new GLfloat[halfCount];
-                        const half *half_pixel = reinterpret_cast<const half *>(pixels);
-                        GLfloat *float_pixel = pixels_as_floats;
-
-                        while (halfCount > 0) {
-                            *float_pixel = *half_pixel;
-                            ++float_pixel;
-                            ++half_pixel;
-                            --halfCount;
-                        }
-                        delete [] pixels;
-                        pixels = reinterpret_cast<quint8 *>(pixels_as_floats);
-                    }
+        case GL_UNSIGNED_SHORT:
+            dstCS = KoColorSpaceRegistry::instance()->rgb16(m_monitorProfile);
+            break;
+        case GL_HALF_FLOAT_ARB:
+            dstCS = KoColorSpaceRegistry::instance()->colorSpace("RGBA", "F16", m_monitorProfile);
+            break;
+        case GL_FLOAT:
+            dstCS = KoColorSpaceRegistry::instance()->colorSpace("RGBA", "F32", m_monitorProfile);
+            break;
 #endif
-                }
-
-                if (tileUpdateRect.width() == m_imageTextureTileWidth && tileUpdateRect.height() == m_imageTextureTileHeight) {
+        default:
+            qFatal("Unknown m_imageTextureType");
+        }
 
-                    glTexImage2D(GL_TEXTURE_2D, 0, m_imageTextureInternalFormat, m_imageTextureTileWidth, m_imageTextureTileHeight, 0,
-                                 GL_BGRA, m_imageTextureType, pixels);
-                } else {
-                    int xOffset = tileUpdateRect.x() - tileRect.x();
-                    int yOffset = tileUpdateRect.y() - tileRect.y();
+        tile.convertTo(dstCS);
 
-                    glTexSubImage2D(GL_TEXTURE_2D, 0, xOffset, yOffset, tileUpdateRect.width(), tileUpdateRect.height(),
-                                    GL_BGRA, m_imageTextureType, pixels);
-                }
+        if (tile.isEntireTileUpdated()) {
+            glTexImage2D(GL_TEXTURE_2D, 0, m_imageTextureInternalFormat, m_imageTextureTileWidth, m_imageTextureTileHeight, 0,
+                         GL_BGRA, m_imageTextureType, tile.data());
+        } else {
+            QPoint patchOffset = tile.patchOffset();
+            QSize patchSize = tile.patchSize();
+            glTexSubImage2D(GL_TEXTURE_2D, 0, patchOffset.x(), patchOffset.y(),
+                            patchSize.width(), patchSize.height(),
+                            GL_BGRA, m_imageTextureType, tile.data());
+        }
 
-                if (deletePixelsAfterUse) {
-                    delete [] pixels;
-                }
+        tile.destroy();
 
-                KIS_OPENGL_PRINT_ERROR();
-            }
-        }
+        KIS_OPENGL_PRINT_ERROR();
     }
 }
 
@@ -363,7 +347,8 @@ int KisOpenGLImageTextures::imageTextureTileHeight() const
 
 void KisOpenGLImageTextures::update(const QRect& imageRect)
 {
-    updateImageTextureTiles(imageRect);
+    KisOpenGLUpdateInfoSP info = updateCache(imageRect);
+    recalculateCache(info);
 }
 
 void KisOpenGLImageTextures::setSelectionDisplayEnabled(bool enable)
@@ -375,14 +360,17 @@ void KisOpenGLImageTextures::slotImageUpdated(const QRect &rc)
 {
     QRect r = rc & m_image->bounds();
 
-    updateImageTextureTiles(r);
+    KisOpenGLUpdateInfoSP info = updateCache(r);
+    recalculateCache(info);
+
     emit sigImageUpdated(r);
 }
 
 void KisOpenGLImageTextures::slotImageSizeChanged(qint32 w, qint32 h)
 {
     createImageTextureTiles();
-    updateImageTextureTiles(m_image->bounds());
+    KisOpenGLUpdateInfoSP info = updateCache(m_image->bounds());
+    recalculateCache(info);
 
     emit sigSizeChanged(w, h);
 }
@@ -391,7 +379,8 @@ void KisOpenGLImageTextures::setMonitorProfile(KoColorProfile *monitorProfile)
 {
     if (monitorProfile != m_monitorProfile) {
         m_monitorProfile = monitorProfile;
-        updateImageTextureTiles(m_image->bounds());
+        KisOpenGLUpdateInfoSP info = updateCache(m_image->bounds());
+        recalculateCache(info);
     }
 }
 
@@ -407,7 +396,8 @@ void KisOpenGLImageTextures::setHDRExposure(float exposure)
             } else {
 #endif
                 QApplication::setOverrideCursor(Qt::WaitCursor);
-                updateImageTextureTiles(m_image->bounds());
+                KisOpenGLUpdateInfoSP info = updateCache(m_image->bounds());
+                recalculateCache(info);
                 QApplication::restoreOverrideCursor();
 #ifdef HAVE_GLEW
             }
@@ -553,7 +543,6 @@ bool KisOpenGLImageTextures::imageCanUseHDRExposureProgram(KisImageWSP image)
               && (GLEW_ARB_texture_float || GLEW_ATI_texture_float))) {
         return false;
     }
-
     return true;
 #else
     Q_UNUSED(image);
diff --git a/krita/ui/opengl/kis_opengl_image_textures.h b/krita/ui/opengl/kis_opengl_image_textures.h
index ca8ad8b..4289fbc 100644
--- a/krita/ui/opengl/kis_opengl_image_textures.h
+++ b/krita/ui/opengl/kis_opengl_image_textures.h
@@ -19,6 +19,8 @@
 #define KIS_OPENGL_IMAGE_TEXTURES_H_
 
 #include <opengl/kis_opengl.h>
+#include "canvas/kis_update_info.h"
+#include "opengl/kis_texture_tile_update_info.h"
 
 #ifdef HAVE_OPENGL
 
@@ -168,7 +170,6 @@ protected:
     void createImageTextureTiles();
     void destroyImageTextureTiles();
     int imageTextureTileIndex(int x, int y) const;
-    void updateImageTextureTiles(const QRect& rect);
 
     void setImageTextureFormat();
 
@@ -176,8 +177,11 @@ protected:
     static bool imageCanUseHDRExposureProgram(KisImageWSP image);
     static bool imageCanShareTextures(KisImageWSP image);
 
-protected slots:
-    void slotImageUpdated(const QRect &);
+public slots:
+    KisOpenGLUpdateInfoSP updateCache(const QRect& rect);
+    void recalculateCache(KisUpdateInfoSP info);
+
+    void slotImageUpdated(const QRect &rc);
     void slotImageSizeChanged(qint32 w, qint32 h);
 
 private:
diff --git a/krita/ui/opengl/kis_texture_tile_update_info.h b/krita/ui/opengl/kis_texture_tile_update_info.h
new file mode 100644
index 0000000..26f702d
--- /dev/null
+++ b/krita/ui/opengl/kis_texture_tile_update_info.h
@@ -0,0 +1,106 @@
+/*
+ *  Copyright (c) 2010, Dmitry Kazakov <dimula73@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+#ifndef KIS_TEXTURE_TILE_UPDATE_INFO_H_
+#define KIS_TEXTURE_TILE_UPDATE_INFO_H_
+
+#ifdef HAVE_OPENGL
+
+#include <KoColorSpace.h>
+#include <KoColorSpaceRegistry.h>
+#include "kis_image.h"
+#include "kis_paint_device.h"
+
+class KisTextureTileUpdateInfo;
+typedef QVector<KisTextureTileUpdateInfo> KisTextureTileUpdateInfoList;
+
+class KisTextureTileUpdateInfo
+{
+public:
+    KisTextureTileUpdateInfo() {
+        m_patchPixels = 0;
+    }
+
+    KisTextureTileUpdateInfo(QRect tileRect, QRect updateRect) {
+        m_tileRect = tileRect;
+        m_patchRect = m_tileRect & updateRect;
+        m_patchPixels = 0;
+    }
+
+    ~KisTextureTileUpdateInfo() {
+    }
+
+    void destroy() {
+        delete[] m_patchPixels;
+    }
+
+    void retrieveData(KisImageWSP image) {
+        m_patchColorSpace = image->projection()->colorSpace();
+
+        m_patchPixels = m_patchColorSpace->allocPixelBuffer(m_patchRect.width() * m_patchRect.height()*2);
+        image->projection()->readBytes(m_patchPixels,
+                                       m_patchRect.x(), m_patchRect.y(),
+                                       m_patchRect.width(), m_patchRect.height());
+    }
+
+    void convertTo(const KoColorSpace* dstCS) {
+        const qint32 numPixels = m_patchRect.width() * m_patchRect.height();
+        /**
+         * FIXME: is it possible to do an in-place conversion?
+         */
+        quint8* dstBuffer = dstCS->allocPixelBuffer(numPixels);
+        // FIXME: rendering intent
+        Q_ASSERT(dstBuffer && m_patchPixels);
+        m_patchColorSpace->convertPixelsTo(m_patchPixels, dstBuffer, dstCS, numPixels);
+        delete[] m_patchPixels;
+        m_patchColorSpace = dstCS;
+        m_patchPixels = dstBuffer;
+    }
+
+    inline quint8* data() {
+        return m_patchPixels;
+    }
+
+    inline bool isEntireTileUpdated() {
+        return m_patchRect == m_tileRect;
+    }
+
+    inline QPoint patchOffset() {
+        return QPoint(m_patchRect.x() - m_tileRect.x(),
+                      m_patchRect.y() - m_tileRect.y());
+    }
+
+    inline QSize patchSize() {
+        return m_patchRect.size();
+    }
+
+    inline QRect tileRect() {
+        return m_tileRect;
+    }
+
+private:
+    QRect m_tileRect;
+    QRect m_patchRect;
+    const KoColorSpace* m_patchColorSpace;
+    quint8 *m_patchPixels;
+};
+
+
+#endif /* HAVE_OPENGL */
+
+#endif /* KIS_TEXTURE_TILE_UPDATE_INFO_H_ */
+
diff --git a/krita/ui/tests/kis_prescaled_projection_test.cpp b/krita/ui/tests/kis_prescaled_projection_test.cpp
index 584a1ff..346909a 100644
--- a/krita/ui/tests/kis_prescaled_projection_test.cpp
+++ b/krita/ui/tests/kis_prescaled_projection_test.cpp
@@ -149,8 +149,6 @@ void KisPrescaledProjectionTest::testCreation()
     KisPrescaledProjection * prescaledProjection = 0;
     prescaledProjection = new KisPrescaledProjection();
     QVERIFY(prescaledProjection != 0);
-    QVERIFY(prescaledProjection->drawCheckers() == false);
-    QVERIFY(prescaledProjection->prescaledPixmap().isNull());
     QVERIFY(prescaledProjection->prescaledQImage().isNull());
     delete prescaledProjection;
 }
@@ -171,17 +169,17 @@ void KisPrescaledProjectionTest::testCoordinateConversionRoundTrip()
     projection.setImage(image);
     projection.resizePrescaledImage(QSize(100, 100));
 
-    QRect viewRect = toAlignedRectWorkaround(projection.viewRectFromImagePixels(QRect(0, 0, 100, 100)));
+    QRect viewRect = projection.viewRectFromImagePixels(QRect(0, 0, 100, 100)).toAlignedRect();
 
     QCOMPARE(viewRect, QRect(0, 0, 40, 40));
 
-    QRect viewRect2 = toAlignedRectWorkaround(projection.viewRectFromImagePixels(QRect(0, 0, 200, 200)));
+    QRect viewRect2 = projection.viewRectFromImagePixels(QRect(0, 0, 200, 200)).toAlignedRect();
     QCOMPARE(viewRect2, QRect(0, 0, 80, 80));
 
     QRect imageRect = projection.imageRectFromViewPortPixels(viewRect);
     QCOMPARE(imageRect, QRect(0, 0, 100, 100));
 
-    QRect viewRect3 = toAlignedRectWorkaround(projection.viewRectFromImagePixels(imageRect));
+    QRect viewRect3 = projection.viewRectFromImagePixels(imageRect).toAlignedRect();
     QCOMPARE(viewRect3, viewRect);
 }
 
